/*
 * say_en_GB.c
 */

/*! \brief  say_number_full_en_GB: British and Norwegian syntax */
/* New files:
 In addition to American English, the following sounds are required:  "and"
 */
static int say_number_full_en_GB(say_args_t *a, int num, const char *options)
{
	int res = 0;
	int playh = 0;
	int playa = 0;
	char fn[256] = "";
	if (!num) 
		return say_digits_full(a, 0);

	while(!res && (num || playh || playa )) {
		if (num < 0) {
			snprintf(fn, sizeof(fn), "digits/minus");
			num = negate(num);
		} else if (playh) {
			snprintf(fn, sizeof(fn), "digits/hundred");
			playh = 0;
		} else if (playa) {
			snprintf(fn, sizeof(fn), "digits/and");
			playa = 0;
		} else if (num < 20) {
			snprintf(fn, sizeof(fn), "digits/%d", num);
			num = 0;
		} else if (num < 100) {
			snprintf(fn, sizeof(fn), "digits/%d", (num /10) * 10);
			num -= ((num / 10) * 10);
		} else if (num < ONE_THOUSAND) {
			int hundreds = num / 100;
			snprintf(fn, sizeof(fn), "digits/%d", hundreds);
			playh++;
			num %= 100;
			if (num)
				playa++;
		} else if (num < ONE_MILLION) {
			res = say_number_full_en_GB(a, num / ONE_THOUSAND, options);
			if (res)
				break;
			snprintf(fn, sizeof(fn), "digits/thousand");
			num = num % ONE_THOUSAND;
			if (num && num < 100)
				playa++;
		} else 	if (num < ONE_BILLION) {
			int millions = num / ONE_MILLION;
			res = say_number_full_en_GB(a, millions, options);
			if (res)
				break;
			snprintf(fn, sizeof(fn), "digits/million");
			num = num % ONE_MILLION;
			if (num && num < 100)
				playa++;
		} else {
			ast_log(LOG_DEBUG, "Number '%d' is too big for me\n", num);
			res = -1;
			break;
		}
		if (!res)
			res = s_streamwait3(a, fn);
	}
	return res;
}

static struct _lang_sw map_en_GB = {
	"en_GB",
	0,
	.say_number_full = say_number_full_en_GB,
};

